'       Figure.bas by Mike Baker

DECLARE FUNCTION UnaryNeg$ (Elemnt$)
DECLARE FUNCTION ResolveParens$ (Elemnt$)
DECLARE FUNCTION ResolveElement$ (Elemnt$)
DECLARE SUB FindNDBkwrd (Elemnt$, ElementPos!, NDChar$, NDPos!)
DECLARE SUB FindNDFwd (Elemnt$, ElementPos!, NDChar$, NDPos!)
DEFINT A-Z
COMMON SHARED ShowWork AS INTEGER
COMMON SHARED FromParens AS INTEGER
COMMON SHARED LeftParenPos AS INTEGER

Param$ = COMMAND$
Param$ = " " + Param$
ShowWorkParam = INSTR(Param$, " /S")
IF ShowWorkParam > 0 THEN
   ShowWork = -1
   Param$ = LEFT$(Param$, ShowWorkParam)
ELSE
   ShowWork = 0
END IF
IF LTRIM$(Param$) = "" THEN
   GOSUB Instructions
ELSE
   Expression$ = Param$
   IF ShowWork THEN PRINT : PRINT "Resolving "; Expression$; " ...ShowWork is ON"
   GOSUB CkParens
   IF ParensOK THEN
      GOSUB ElimSp
      FromParens = -1
      Expression$ = ResolveParens$(Expression$)
      FromParens = 0
      Expression$ = ResolveElement$(Expression$)
      PRINT Expression$
   ELSE
      PRINT "Unbalanced Parens: ";
      IF CloseIsFirst THEN
         PRINT "A closing paren occurs before an opening paren"
      ELSE
         PRINT LParen; "open"; : IF LParen > 1 THEN PRINT "s";
         PRINT " and";
         PRINT RParen; "close"; : IF RParen > 1 THEN PRINT "s" ELSE PRINT
      END IF
   END IF
END IF
END

ElimSp:
   'input Expression$
   'output Expression$
   SpPos = 1 'force entry into following
   DO WHILE SpPos > 0
      SpPos = INSTR(Expression$, " ")
      IF SpPos > 0 THEN Expression$ = LEFT$(Expression$, SpPos - 1) + RIGHT$(Expression$, LEN(Expression$) - SpPos)
   LOOP
   RETURN

CkParens:
   LParen = 0: RParen = 0
   FOR CkParen = 1 TO LEN(Expression$)
      Char$ = MID$(Expression$, CkParen, 1)
      IF Char$ = "(" THEN LParen = LParen + 1
      IF Char$ = ")" THEN RParen = RParen + 1: IF LParen = 0 THEN CloseIsFirst = -1
   NEXT CkParen
   IF LParen = RParen THEN
      IF CloseIsFirst THEN
         ParensOK = 0
      ELSE
         ParensOK = -1
      END IF
   ELSE
      ParensOK = 0
   END IF
   RETURN

Instructions:
   PRINT : PRINT "Welcome to FIGURE by Mike Baker"
   PRINT
   PRINT "figure [expression] [/s]"
   PRINT "   expression = a numeric expression"
   PRINT "   /s         = show step by step work"
   PRINT
   PRINT "EXAMPLE:   FIGURE ((((1 * 2) / 3) ^ 3) + 15) /s"
   PRINT
   RETURN

DEFSNG A-Z
SUB FindNDBkwrd (Elemnt$, ElementPos, NDChar$, NDPos)
   NDPos = ElementPos
   DO WHILE NDPos > 0
      'note; - is allowed on bkwds as unary sign
      IF INSTR("0123456789.-E", MID$(Elemnt$, NDPos, 1)) = 0 THEN
         'is Non-Digit
         NDChar$ = MID$(Elemnt$, NDPos, 1)
         EXIT DO
      END IF
      NDPos = NDPos - 1
   LOOP
END SUB

SUB FindNDFwd (Elemnt$, ElementPos, NDChar$, NDPos)
   NDPos = ElementPos
   DO UNTIL NDPos > LEN(Elemnt$)
      IF INSTR("0123456789.E-", MID$(Elemnt$, NDPos, 1)) = 0 THEN
         'is non-digit
         NDChar$ = MID$(Elemnt$, NDPos, 1)
         EXIT DO
      END IF
      NDPos = NDPos + 1
   LOOP
END SUB

FUNCTION ResolveElement$ (Elemnt$)
   SHARED ShowWork AS INTEGER
   SHARED FromParens AS INTEGER
   SHARED LeftParenPos AS INTEGER
   Elemnt$ = UnaryNeg$(Elemnt$)
   'order of operators provides precidence
   AllOperations$ = "^*/+"  '  - is an unary sign NOT an operator
   'loop through all operators
   FOR Operation = 1 TO LEN(AllOperations$)
      StartSearchPos = 1
      'get the operator
      Operator$ = MID$(AllOperations$, Operation, 1)
      'loop until all calculations of the CURRENT operator have been done
      'operations are done left to right
      DO WHILE INSTR(StartSearchPos, Elemnt$, Operator$) > 0
        'find operator position
         ElementPos = INSTR(StartSearchPos, Elemnt$, Operator$)
        'find left sub-element
         CALL FindNDBkwrd(Elemnt$, ElementPos - 1, NDBk$, NDPos)
         CalcElem1$ = MID$(Elemnt$, NDPos + 1, ElementPos - (NDPos + 1))
        'value of left sub-element
         CalcElem1! = VAL(CalcElem1$)
        'other stuff to left of left sub-element
         ElementLeft$ = LEFT$(Elemnt$, NDPos)
        'find right sub-element
         CALL FindNDFwd(Elemnt$, ElementPos + 1, NDFd$, NDPos)
         CalcElem2$ = MID$(Elemnt$, ElementPos + 1, NDPos - ElementPos - 1)
        'value of right sub-element
         CalcElem2! = VAL(CalcElem2$)
        'other stuff to right of right sub-element
         ElementRt$ = RIGHT$(Elemnt$, LEN(Elemnt$) - NDPos + 1)
         IF ShowWork THEN
            IF FromParens THEN PRINT STRING$(LeftParenPos - 1, " "); "(";
            PRINT ElementLeft$;
            COLOR 15, 0
            PRINT CalcElem1$; Operator$; CalcElem2$;
            COLOR 7, 0
            PRINT ElementRt$;
            IF FromParens THEN PRINT ")" ELSE PRINT
         END IF
         SELECT CASE Operator$
            CASE IS = "+"
               CalcElem! = CalcElem1! + CalcElem2!
            CASE IS = "/"
               CalcElem! = CalcElem1! / CalcElem2!
            CASE IS = "*"
               CalcElem! = CalcElem1! * CalcElem2!
            CASE IS = "^"
               CalcElem! = CalcElem1! ^ CalcElem2!
            CASE IS = "\"
               CalcElem! = CalcElem1! \ CalcElem2!
         END SELECT
         CalcElem$ = LTRIM$(RTRIM$(STR$(CalcElem!)))
         Elemnt$ = ElementLeft$ + CalcElem$ + ElementRt$
      LOOP
   NEXT Operation
   IF ShowWork THEN
      IF FromParens THEN PRINT STRING$(LeftParenPos - 1, " "); "(";
      COLOR 15, 0: PRINT Elemnt$; : COLOR 7, 0
      IF FromParens THEN PRINT ")" ELSE PRINT
   END IF
   ResolveElement$ = Elemnt$
END FUNCTION

FUNCTION ResolveParens$ (Elemnt$)
   SHARED ShowWork AS INTEGER
   SHARED LeftParenPos AS INTEGER
   DO WHILE INSTR(Elemnt$, "(") > 0     'do while an opening paren exists
      'Mark 1st left Paren
      LeftParenPos = INSTR(1, Elemnt$, "(")
      '1st Right Paren will be end of innermost paren! ! !
      RtParenPos = INSTR(1, Elemnt$, ")")
      LastLeftBeforeRt = 0   'is a switch (turn off)
      DO UNTIL LastLeftBeforeRt         'find last open paren before close
         NextLeft = INSTR(LeftParenPos + 1, Elemnt$, "(")
         '(if no more opens, then NextLeft will be 0 ! ! !)
         IF NextLeft > LeftParenPos AND NextLeft < RtParenPos THEN
            'found another open paren before the right paren
            LeftParenPos = NextLeft
         ELSE
            'did NOT find another open paren before close;
            'means that last one we found was innermost ! ! !
            LastLeftBeforeRt = -1       'turn on done switch
         END IF
      LOOP
      'save what is before open paren
      ElementLeft$ = LEFT$(Elemnt$, LeftParenPos - 1)
      'save what is after close paren
      ElementRt$ = RIGHT$(Elemnt$, LEN(Elemnt$) - RtParenPos)
      'get what is inside parens
      InParens$ = MID$(Elemnt$, LeftParenPos + 1, RtParenPos - LeftParenPos - 1)
      IF ShowWork THEN
         PRINT ElementLeft$;
         COLOR 15, 0: PRINT "(" + InParens$ + ")"; : COLOR 7, 0
         PRINT ElementRt$
      END IF
      InParens$ = ResolveElement$(InParens$)    'calculate it
      'rebuild expression combine before, resolved inside & after parens
      Elemnt$ = ElementLeft$ + InParens$ + ElementRt$
   LOOP
   ResolveParens$ = Elemnt$
END FUNCTION

FUNCTION UnaryNeg$ (Elemnt$)
'purpose is to be able to handle negative numbers (ie. -1 + -5),
'easiest way is to consider ALL "-"'s as unary signs!
'function finds all "-" OPERATIONS and changes them to "+-"'s
   Length = LEN(Elemnt$)
   Position = 2
   DO WHILE Position <= Length
      Char$ = MID$(Elemnt$, Position, 1)
      IF Char$ = "-" THEN
         IF INSTR("0123456789", MID$(Elemnt$, Position - 1, 1)) > 0 THEN 'is subtract, chg to unary
            Elemnt$ = LEFT$(Elemnt$, Position - 1) + "+" + RIGHT$(Elemnt$, Length - Position + 1)
            Length = LEN(Elemnt$)
            Position = Position + 1
         END IF
      END IF
   Position = Position + 1
   LOOP
   UnaryNeg$ = Elemnt$
END FUNCTION

